/************************************************************************************/
/*  Program name CAPAPEXT_SELECT_INV_CHECKS.sql                                     */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
set verify off;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPEXT_SELECT_INV_CHECKS';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPAP_SELECT_INV_CHECKS.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_B (p_NGO VARCHAR2) IS
	SELECT
		F.*,
		B.Name	OU_Name
	FROM
		AP_SELECTED_INVOICE_CHECKS_ALL	F,
		HR_ALL_ORGANIZATION_UNITS		B,
		HR_ORGANIZATION_INFORMATION		I
	WHERE	SUBSTR(B.Name,4,4)			=	p_NGO
	AND		B.Organization_ID			=	F.Org_ID
	AND		B.Organization_ID			=	I.Organization_ID
	AND		I.Org_Information_Context	=	'Operating Unit Information';

BEGIN
	lv_NGO		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_B(lv_NGO) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Checkrun_Name||CHR(9)||
				C1.Check_Number||CHR(9)||
					C1.Vendor_ID||CHR(9)||
					C1.Vendor_Site_ID||CHR(9)||
				C1.Print_Sequence_Num||CHR(9)||
				C1.Check_Amount||CHR(9)||
				C1.Vendor_Amount||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.OK_To_Pay_Flag||CHR(9)||
				C1.Dont_Pay_Reason_Code||CHR(9)||
				C1.Status_Lookup_Code||CHR(9)||
				C1.Vendor_Num||CHR(9)||
				C1.Vendor_Name||CHR(9)||
				C1.Vendor_Site_Code||CHR(9)||
				C1.Customer_Num||CHR(9)||
				C1.Address_Line1||CHR(9)||
				C1.Address_Line2||CHR(9)||
				C1.Address_Line3||CHR(9)||
				C1.City||CHR(9)||
				C1.State||CHR(9)||
				C1.Zip||CHR(9)||
				C1.Province||CHR(9)||
				C1.Country||CHR(9)||
				C1.Withholding_Status_Lookup_Code||CHR(9)||
				C1.Void_Flag||CHR(9)||
				C1.Check_ID||CHR(9)||
				C1.Currency_Code||CHR(9)||
				C1.Discount_Amount||CHR(9)||
				C1.Bank_Account_Num||CHR(9)||
				C1.Bank_Num||CHR(9)||
				C1.Bank_Account_Type||CHR(9)||
				C1.Check_Voucher_Num||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Creation_Date||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Future_Pay_Due_Date||CHR(9)||
				C1.Due_Date||CHR(9)||
				C1.Payment_Date||CHR(9)||
				C1.Selected_Check_ID||CHR(9)||
				C1.Attention_Ar_Flag||CHR(9)||
					C1.Org_ID||CHR(9)||
				C1.Transfer_Priority||CHR(9)||
					C1.External_Bank_Account_ID||CHR(9)||		--  Bank Account Mapping
				C1.Address_Line4||CHR(9)||
				C1.IBAN_Number||CHR(9)||
				CAPBREXT_COMMON.GetVendorName(C1.Vendor_ID)||CHR(9)||
				CAPBREXT_COMMON.GetVendorSiteCode(C1.Vendor_ID,C1.Vendor_Site_ID)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)||CHR(9)||
				C1.OU_Name
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/